#ifndef __TRTL_ADDRESSES_H
#define __TRTL_ADDRESSES_H

#ifdef __KERNEL__

#define TRTL_ADDR_OFFSET_HMQ        0x00000000
#define TRTL_ADDR_OFFSET_CSR        0x0000C000
#define TRTL_ADDR_OFFSET_CONFIG_ROM 0x0000E000
#define TRTL_ADDR_OFFSET_SHM        0x00010000

#else

#define TRTL_ADDR_SI_BASE              0x40000000
#define TRTL_ADDR_SI_OFFSET_HMQ        0x00000000
#define TRTL_ADDR_SI_OFFSET_RMQ        0x00100000
#define TRTL_ADDR_SI_OFFSET_SHM        0x00200000
#define TRTL_ADDR_SI_OFFSET_CONFIG_ROM 0x00400000

/**
 * Dedicated Peripheral base address.
 * All the Dedicated Paripherals will be behind this address
 */
#define TRTL_ADDR_DP_BASE              0x00200000
/**
 * CPU Local Registers base address
 */
#define TRTL_ADDR_LR_BASE              0x00100000

/**
 * It gives a nice pointer to the given register in the dedicated peripheral
 */
#define TRTL_ADDR_DP(_offset) ((void *)(TRTL_ADDR_DP_BASE + _offset))

/**
 * It gives a nice pointer to the given register in the local register area
 */
#define TRTL_ADDR_LR(_offset) ((void *)(TRTL_ADDR_LR_BASE + _offset))

/**
 *
 */
#define TRTL_ADDR_SI(_offset) ((void *)(TRTL_ADDR_SI_BASE + _offset))
#endif /* */

#endif
